//+------------------------------------------------------------------+
//|                                           ObjectCreateAndSet.mqh |
//|                                                2015, Dina Paches |
//|                           https://login.mql5.com/ru/users/dipach |
//+------------------------------------------------------------------+
#property copyright "Dina Paches"
#property link      "https://login.mql5.com/ru/users/dipach"
#define LINE_NUMBER    "Line: ",__LINE__,", "
/*    ,     
 : 
#include <ObjectCreateAndSet.mqh>*/
//+------------------------------------------------------------------+
//|                                        |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                          |
//+------------------------------------------------------------------+
//|  :                                                       |
//|  MQL5 /  ,   | 
//| /    /   / OBJ_VLINE                |
//+------------------------------------------------------------------+
bool VLineCreate(const long            chart_ID=0,        // ID 
                 const string          name="VLine",      //  
                 const int             sub_window=0,      //  
                 datetime              time=0,            //  
                 const string          toolTip="\n",      //   
                 const color           clr=clrRed,        //  
                 const ENUM_LINE_STYLE style=STYLE_SOLID, //  
                 const int             width=1,           //  
                 const bool            back=false,        //   
                 const bool            selection=true,    //   
                 const bool            ray=true,          //   
                 const bool            hidden=true,       //    
                 const long            z_order=0,         //    
                 const int             timeFrames=OBJ_ALL_PERIODS)//    
  {
//---     ,      
   if(!time)
      time=TimeCurrent();
//---   
   ResetLastError();
//---   
   if(!ObjectCreate(chart_ID,name,OBJ_VLINE,sub_window,time,0))
     {
      Print(LINE_NUMBER,__FUNCTION__,
            ": failed to create a vertical line! Error code = ",GetLastError());
      return(false);
     }
//---    
   ObSetString(chart_ID,name,OBJPROP_TOOLTIP,toolTip);
//---     
   ObSetIntegerColor(chart_ID,name,OBJPROP_COLOR,clr);
//---    
   ObSetIntegerLineStyle(chart_ID,name,style);
//---   
   ObSetIntegerInt(chart_ID,name,OBJPROP_WIDTH,width);
//---    (false)   (true) 
   ObSetIntegerBool(chart_ID,name,OBJPROP_BACK,back);
//---  (true)   (false)    
//---      ObjectCreate,   
//---    .      selection
//---    true,       
   ObSetIntegerBool(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObSetIntegerBool(chart_ID,name,OBJPROP_SELECTED,selection);
//---  (true)   (false)      
   ObSetIntegerBool(chart_ID,name,OBJPROP_RAY,ray);
//---  (true)   (false)      
   ObSetIntegerBool(chart_ID,name,OBJPROP_HIDDEN,hidden);
//---         
   ObSetIntegerLong(chart_ID,name,OBJPROP_ZORDER,z_order);
//---        
   ObSetIntegerInt(chart_ID,name,OBJPROP_TIMEFRAMES,timeFrames);
//---  
   return(true);
  }
//+------------------------------------------------------------------+
//|                                        |
//+------------------------------------------------------------------+
//|  :                                                       |
//|  MQL5 /  ,   |
//| /    /   / OBJ_HLINE                |
//+------------------------------------------------------------------+
bool HLineCreate(const long            chart_ID=0,        // ID 
                 const string          name="HLine",      //  
                 const int             sub_window=0,      //  
                 double                price=0,           //  
                 const string          toolTip="\n",      //   
                 const color           clr=clrRed,        //  
                 const ENUM_LINE_STYLE style=STYLE_SOLID, //  
                 const int             line_width=1,      //  
                 const bool            back=false,        //   
                 const bool            selection=true,    //   
                 const bool            hidden=true,       //    
                 const long            z_order=0,         //    
                 const int             timeFrames=OBJ_ALL_PERIODS)//    
  {
//---   
   ResetLastError();
//---   
   if(!ObjectCreate(chart_ID,name,OBJ_HLINE,sub_window,0,price))
     {
      Print(LINE_NUMBER,__FUNCTION__,
            ": failed to create a horizontal line! Error code = ",GetLastError());
      return(false);
     }
//---    
   ObSetString(chart_ID,name,OBJPROP_TOOLTIP,toolTip);
//---     
   ObSetIntegerColor(chart_ID,name,OBJPROP_COLOR,clr);
//---    
   ObSetIntegerLineStyle(chart_ID,name,style);
//---   
   ObSetIntegerInt(chart_ID,name,OBJPROP_WIDTH,line_width);
//---    (false)   (true) 
   ObSetIntegerBool(chart_ID,name,OBJPROP_BACK,back);
//---  (true)   (false)    
//---      ObjectCreate,   
//---    .      selection
//---    true,       
   ObSetIntegerBool(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObSetIntegerBool(chart_ID,name,OBJPROP_SELECTED,selection);
//---  (true)   (false)      
   ObSetIntegerBool(chart_ID,name,OBJPROP_HIDDEN,hidden);
//---         
   ObSetIntegerLong(chart_ID,name,OBJPROP_ZORDER,z_order);
//---        
   ObSetIntegerInt(chart_ID,name,OBJPROP_TIMEFRAMES,timeFrames);
//---  
   return(true);
  }
//+------------------------------------------------------------------+
//|                           |
//+------------------------------------------------------------------+
//|  :                                                       |
//|  MQL5 /  ,   |
//| /    /   / OBJ_TREND                |
//+------------------------------------------------------------------+
bool TrendCreate(const long            chart_ID=0,        // ID 
                 const string          name="TrendLine",  //  
                 const int             sub_window=0,      //  
                 datetime              time1=0,           //   
                 double                price1=0,          //   
                 datetime              time2=0,           //   
                 double                price2=0,          //   
                 const string          toolTip="\n",      //        
                 const color           clr=clrRed,        //  
                 const ENUM_LINE_STYLE style=STYLE_SOLID, //  
                 const int             width=1,           //  
                 const bool            back=false,        //   
                 const bool            selection=true,    //   
                 const bool            ray_left=false,    //   
                 const bool            ray_right=false,   //   
                 const bool            hidden=true,       //    
                 const long            z_order=0,         //    
                 const int             timeFrames=OBJ_ALL_PERIODS)//    
  {
//---   
   ResetLastError();
//---      
   if(!ObjectCreate(chart_ID,name,OBJ_TREND,sub_window,time1,price1,time2,price2))
     {
      Print(LINE_NUMBER,__FUNCTION__,
            ": failed to create a trend line! Error code = ",GetLastError());
      return(false);
     }
//---    
   ObSetString(chart_ID,name,OBJPROP_TOOLTIP,toolTip);
//---     
   ObSetIntegerColor(chart_ID,name,OBJPROP_COLOR,clr);
//---    
   ObSetIntegerLineStyle(chart_ID,name,style);
//---   
   ObSetIntegerInt(chart_ID,name,OBJPROP_WIDTH,width);
//---    (false)   (true) 
   ObSetIntegerBool(chart_ID,name,OBJPROP_BACK,back);
//---  (true)   (false)    
//---      ObjectCreate,   
//---    .      selection
//---    true,       
   ObSetIntegerBool(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObSetIntegerBool(chart_ID,name,OBJPROP_SELECTED,selection);
//---  (true)   (false)     
   ObSetIntegerBool(chart_ID,name,OBJPROP_RAY_LEFT,ray_left);
//---  (true)   (false)     
   ObSetIntegerBool(chart_ID,name,OBJPROP_RAY_RIGHT,ray_right);
//---  (true)   (false)      
   ObSetIntegerBool(chart_ID,name,OBJPROP_HIDDEN,hidden);
//---         
   ObSetIntegerLong(chart_ID,name,OBJPROP_ZORDER,z_order);
//---        
   ObSetIntegerInt(chart_ID,name,OBJPROP_TIMEFRAMES,timeFrames);
//---  
   return(true);
  }
//+------------------------------------------------------------------+
//|                       |
//+------------------------------------------------------------------+
//|  :                                                       |
//|  MQL5 /  ,   |
//| /    /   / OBJ_ARROWED_LINE         |
//+------------------------------------------------------------------+
bool ArrowedLineCreate(const long            chart_ID=0,         // ID 
                       const string          name="ArrowedLine", //  
                       const int             sub_window=0,       //  
                       datetime              time1=0,            //   
                       double                price1=0,           //   
                       datetime              time2=0,            //   
                       double                price2=0,           //   
                       const string          toolTip="\n",       //   
                       const color           clr=clrRed,         //  
                       const ENUM_LINE_STYLE style=STYLE_SOLID,  //  
                       const int             width=1,            //  
                       const bool            back=false,         //   
                       const bool            selection=true,     //   
                       const bool            hidden=true,        //    
                       const long            z_order=0,          //    
                       const int             timeFrames=OBJ_ALL_PERIODS)//    
  {
//---   
   ResetLastError();
//---       
   if(!ObjectCreate(chart_ID,name,OBJ_ARROWED_LINE,sub_window,time1,price1,time2,price2))
     {
      Print(__FUNCTION__,
            ": failed to create an arrowed line! Error code = ",GetLastError());
      return(false);
     }
//---    
   ObSetString(chart_ID,name,OBJPROP_TOOLTIP,toolTip);
//---    
   ObSetIntegerColor(chart_ID,name,OBJPROP_COLOR,clr);
//---    
   ObSetIntegerLineStyle(chart_ID,name,style);
//---   
   ObSetIntegerInt(chart_ID,name,OBJPROP_WIDTH,width);
//---    (false)   (true) 
   ObSetIntegerBool(chart_ID,name,OBJPROP_BACK,back);
//---  (true)   (false)    
//---      ObjectCreate,   
//---    .      selection
//---    true,       
   ObSetIntegerBool(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObSetIntegerBool(chart_ID,name,OBJPROP_SELECTED,selection);
//---  (true)   (false)      
   ObSetIntegerBool(chart_ID,name,OBJPROP_HIDDEN,hidden);
//---         
   ObSetIntegerLong(chart_ID,name,OBJPROP_ZORDER,z_order);
//---        
   ObSetIntegerInt(chart_ID,name,OBJPROP_TIMEFRAMES,timeFrames);
//---  
   return(true);
  }
//+------------------------------------------------------------------+
//| C                  |
//+------------------------------------------------------------------+
//|  :                                                       |
//|  MQL5 /  ,   |
//| /    /   / OBJ_CHANNEL              |
//+------------------------------------------------------------------+
bool ChannelCreate(const long            chart_ID=0,        // ID 
                   const string          name="Channel",    //  
                   const int             sub_window=0,      //   
                   datetime              time1=0,           //   
                   double                price1=0,          //   
                   datetime              time2=0,           //   
                   double                price2=0,          //   
                   datetime              time3=0,           //   
                   double                price3=0,          //   
                   const string          toolTip="\n",      //   
                   const color           clr=clrRed,        //  
                   const ENUM_LINE_STYLE style=STYLE_SOLID, //   
                   const int             line_width=1,      //   
                   const bool            fill=false,        //   
                   const bool            back=false,        //   
                   const bool            selection=true,    //   
                   const bool            ray_left=false,    //   
                   const bool            ray_right=false,   //   
                   const bool            hidden=true,       //    
                   const long            z_order=0,         //    
                   const int             timeFrames=OBJ_ALL_PERIODS)//    
  {
//---   
   ResetLastError();
//---     
   if(!ObjectCreate(chart_ID,name,OBJ_CHANNEL,sub_window,time1,price1,time2,price2,time3,price3))
     {
      Print(__FUNCTION__,
            ": failed to create an equidistant channel! Error code = ",GetLastError());
      return(false);
     }
//---    
   ObSetString(chart_ID,name,OBJPROP_TOOLTIP,toolTip);
//---   
   ObSetIntegerColor(chart_ID,name,OBJPROP_COLOR,clr);
//---    
   ObSetIntegerLineStyle(chart_ID,name,style);
//---    
   ObSetIntegerInt(chart_ID,name,OBJPROP_WIDTH,line_width);
//---  (true)   (false)   
   ObSetIntegerBool(chart_ID,name,OBJPROP_FILL,fill);
//---    (false)   (true) 
   ObSetIntegerBool(chart_ID,name,OBJPROP_BACK,back);
//---  (true)   (false)     
//---      ObjectCreate,   
//---    .      selection
//---    true,       
   ObSetIntegerBool(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObSetIntegerBool(chart_ID,name,OBJPROP_SELECTED,selection);
//---  (true)   (false)     
   ObSetIntegerBool(chart_ID,name,OBJPROP_RAY_LEFT,ray_left);
//---  (true)   (false)     
   ObSetIntegerBool(chart_ID,name,OBJPROP_RAY_RIGHT,ray_right);
//---  (true)   (false)      
   ObSetIntegerBool(chart_ID,name,OBJPROP_HIDDEN,hidden);
//---         
   ObSetIntegerLong(chart_ID,name,OBJPROP_ZORDER,z_order);
//---        
   ObSetIntegerInt(chart_ID,name,OBJPROP_TIMEFRAMES,timeFrames);
//---  
   return(true);
  }
//+------------------------------------------------------------------+
//| C                        |
//+------------------------------------------------------------------+
//|  :                                                       |
//|  MQL5 /  ,   |
//| /    /   / OBJ_RECTANGLE            |    
//+------------------------------------------------------------------+
bool RectangleCreate(const long            chart_ID=0,        // ID 
                     const string          name="Rectangle",  //  
                     const int             sub_window=0,      //   
                     datetime              time1=0,           //   
                     double                price1=0,          //   
                     datetime              time2=0,           //   
                     double                price2=0,          //   
                     const string          toolTip="\n",      //   
                     const color           clr=clrRed,        //  
                     const ENUM_LINE_STYLE style=STYLE_SOLID, //   
                     const int             line_width=1,      //   
                     const bool            fill=false,        //   
                     const bool            back=false,        //   
                     const bool            selection=true,    //   
                     const bool            hidden=true,       //    
                     const long            z_order=0,         //    
                     const int             timeFrames=OBJ_ALL_PERIODS)//    
  {
//---   
   ResetLastError();
//---     
   if(!ObjectCreate(chart_ID,name,OBJ_RECTANGLE,sub_window,time1,price1,time2,price2))
     {
      Print(LINE_NUMBER,__FUNCTION__,
            ": failed to create a rectangle! Error code = ",GetLastError());
      return(false);
     }
//---    
   ObSetString(chart_ID,name,OBJPROP_TOOLTIP,toolTip);
//---   
   ObSetIntegerColor(chart_ID,name,OBJPROP_COLOR,clr);
//---    
   ObSetIntegerLineStyle(chart_ID,name,style);
//---    
   ObSetIntegerInt(chart_ID,name,OBJPROP_WIDTH,line_width);
//---  (true)   (false)   
   ObSetIntegerBool(chart_ID,name,OBJPROP_FILL,fill);
//---    (false)   (true) 
   ObSetIntegerBool(chart_ID,name,OBJPROP_BACK,back);
//---  (true)   (false)     
//---      ObjectCreate,   
//---    .      selection
//---    true,       
   ObSetIntegerBool(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObSetIntegerBool(chart_ID,name,OBJPROP_SELECTED,selection);
//---  (true)   (false)      
   ObSetIntegerBool(chart_ID,name,OBJPROP_HIDDEN,hidden);
//---         
   ObSetIntegerLong(chart_ID,name,OBJPROP_ZORDER,z_order);
//---        
   ObSetIntegerInt(chart_ID,name,OBJPROP_TIMEFRAMES,timeFrames);
//---  
   return(true);
  }
//+------------------------------------------------------------------+
//| C                          |
//+------------------------------------------------------------------+
//|  :                                                       |
//|  MQL5 /  ,   |
//| /    /   / OBJ_TRIANGLE             |
//+------------------------------------------------------------------+
bool TriangleCreate(const long            chart_ID=0,        // ID 
                    const string          name="Triangle",   //  
                    const int             sub_window=0,      //   
                    datetime              time1=0,           //   
                    double                price1=0,          //   
                    datetime              time2=0,           //   
                    double                price2=0,          //   
                    datetime              time3=0,           //   
                    double                price3=0,          //   
                    const string          toolTip="\n",      //   
                    const color           clr=clrRed,        //  
                    const ENUM_LINE_STYLE style=STYLE_SOLID, //   
                    const int             width=1,           //   
                    const bool            fill=false,        //   
                    const bool            back=false,        //   
                    const bool            selection=true,    //   
                    const bool            hidden=true,       //    
                    const long            z_order=0,         //    
                    const int             timeFrames=OBJ_ALL_PERIODS)//    
  {
//---   
   ResetLastError();
//---     
   if(!ObjectCreate(chart_ID,name,OBJ_TRIANGLE,sub_window,time1,price1,time2,price2,time3,price3))
     {
      Print(__FUNCTION__,
            ": failed to create a triangle! Error code = ",GetLastError());
      return(false);
     }
//---    
   ObSetString(chart_ID,name,OBJPROP_TOOLTIP,toolTip);
//---   
   ObSetIntegerColor(chart_ID,name,OBJPROP_COLOR,clr);
//---    
   ObSetIntegerLineStyle(chart_ID,name,style);
//---    
   ObSetIntegerInt(chart_ID,name,OBJPROP_WIDTH,width);
//---  (true)   (false)   
   ObSetIntegerBool(chart_ID,name,OBJPROP_FILL,fill);
//---    (false)   (true) 
   ObSetIntegerBool(chart_ID,name,OBJPROP_BACK,back);
//---  (true)   (false)     
//---      ObjectCreate,   
//---    .      selection
//---    true,       
   ObSetIntegerBool(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObSetIntegerBool(chart_ID,name,OBJPROP_SELECTED,selection);
//---  (true)   (false)      
   ObSetIntegerBool(chart_ID,name,OBJPROP_HIDDEN,hidden);
//---         
   ObSetIntegerLong(chart_ID,name,OBJPROP_ZORDER,z_order);
//---        
   ObSetIntegerInt(chart_ID,name,OBJPROP_TIMEFRAMES,timeFrames);
//---  
   return(true);
  }
//+------------------------------------------------------------------+
//| C                               |
//+------------------------------------------------------------------+
//|  :                                                       |
//|  MQL5 /  ,   |
//| /    /   / OBJ_ELLIPSE              |
//+------------------------------------------------------------------+
bool EllipseCreate(const long            chart_ID=0,        // ID 
                   const string          name="Ellipse",    //  
                   const int             sub_window=0,      //   
                   datetime              time1=0,           //   
                   double                price1=0,          //   
                   datetime              time2=0,           //   
                   double                price2=0,          //   
                   datetime              time3=0,           //   
                   double                price3=0,          //   
                   const string          toolTip="\n",      //   
                   const color           clr=clrRed,        //  
                   const ENUM_LINE_STYLE style=STYLE_SOLID, //   
                   const int             width=1,           //   
                   const bool            fill=false,        //   
                   const bool            back=false,        //   
                   const bool            selection=true,    //   
                   const bool            hidden=true,       //    
                   const long            z_order=0,         //    
                   const int             timeFrames=OBJ_ALL_PERIODS)//    
  {
//---   
   ResetLastError();
//---     
   if(!ObjectCreate(chart_ID,name,OBJ_ELLIPSE,sub_window,time1,price1,time2,price2,time3,price3))
     {
      Print(__FUNCTION__,
            ": failed to create an ellipse! Error code = ",GetLastError());
      return(false);
     }
//---    
   ObSetString(chart_ID,name,OBJPROP_TOOLTIP,toolTip);
//---   
   ObSetIntegerColor(chart_ID,name,OBJPROP_COLOR,clr);
//---    
   ObSetIntegerLineStyle(chart_ID,name,style);
//---    
   ObSetIntegerInt(chart_ID,name,OBJPROP_WIDTH,width);
//---  (true)   (false)   
   ObSetIntegerBool(chart_ID,name,OBJPROP_FILL,fill);
//---    (false)   (true) 
   ObSetIntegerBool(chart_ID,name,OBJPROP_BACK,back);
//---  (true)   (false)     
//---      ObjectCreate,   
//---    .      selection
//---    true,       
   ObSetIntegerBool(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObSetIntegerBool(chart_ID,name,OBJPROP_SELECTED,selection);
//---  (true)   (false)      
   ObSetIntegerBool(chart_ID,name,OBJPROP_HIDDEN,hidden);
//---         
   ObSetIntegerLong(chart_ID,name,OBJPROP_ZORDER,z_order);
//---        
   ObSetIntegerInt(chart_ID,name,OBJPROP_TIMEFRAMES,timeFrames);
//---  
   return(true);
  }
//+------------------------------------------------------------------+
//|  OBJ_ARROW                                                |
//+------------------------------------------------------------------+
//|  :                                                       |
//|  MQL5 /  ,   |
//| /    /   / OBJ_ARROW                |
//+------------------------------------------------------------------+
bool ArrowCreate(const long              chart_ID=0,           // ID 
                 const string            name="Arrow",         //  
                 const int               sub_window=0,         //  
                 datetime                time=0,               //   
                 double                  price=0,              //   
                 const uchar             arrow_code=252,       //  
                 const string            toolTip="\n",         //   
                 const ENUM_ARROW_ANCHOR anchor=ANCHOR_BOTTOM, //   
                 const color             clr=clrRed,           //  
                 const ENUM_LINE_STYLE   style=STYLE_SOLID,    //   
                 const int               line_width=3,//  
                 const bool              back=false,           //   
                 const bool              selection=true,       //   
                 const bool              hidden=true,          //    
                 const long              z_order=0,            //    
                 const int               timeFrames=OBJ_ALL_PERIODS)//    
  {
//---   
   ResetLastError();
//---  
   if(!ObjectCreate(chart_ID,name,OBJ_ARROW,sub_window,time,price))
     {
      Print(__FUNCTION__,
            ": failed to create an arrow! Error code = ",GetLastError());
      return(false);
     }
//---    
   ObSetString(chart_ID,name,OBJPROP_TOOLTIP,toolTip);
//---   
   ObSetIntegerArrowCode(chart_ID,name,arrow_code);
//---   
   ObSetIntegerArrowAncor(chart_ID,name,anchor);
//---   
   ObSetIntegerColor(chart_ID,name,OBJPROP_COLOR,clr);
//---    
   ObSetIntegerLineStyle(chart_ID,name,style);
//---   
   ObSetIntegerInt(chart_ID,name,OBJPROP_WIDTH,line_width);
//---    (false)   (true) 
   ObSetIntegerBool(chart_ID,name,OBJPROP_BACK,back);
//---  (true)   (false)    
//---      ObjectCreate,   
//---    .      selection
//---    true,       
   ObSetIntegerBool(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObSetIntegerBool(chart_ID,name,OBJPROP_SELECTED,selection);
//---  (true)   (false)      
   ObSetIntegerBool(chart_ID,name,OBJPROP_HIDDEN,hidden);
//---         
   ObSetIntegerLong(chart_ID,name,OBJPROP_ZORDER,z_order);
//---        
   ObSetIntegerInt(chart_ID,name,OBJPROP_TIMEFRAMES,timeFrames);
//---  
   return(true);
  }
//+------------------------------------------------------------------+
//|   ""                                           |
//+------------------------------------------------------------------+
//|  :                                                       |
//|  MQL5 /  ,   |
//| /    /   / OBJ_TEXT                 |
//+------------------------------------------------------------------+
bool TextCreate(const long              chart_ID=0,               // ID 
                const string            name="Text",              //  
                const int               sub_window=0,             //  
                datetime                time=0,                   //   
                double                  price=0,                  //   
                const string            text="Text",              //  
                const string            toolTip="\n",             //   
                const string            font="Arial",             // 
                const int               font_size=10,             //  
                const color             clr=clrRed,               // 
                const double            angle=0.0,                //  
                const ENUM_ANCHOR_POINT anchor=ANCHOR_LEFT_UPPER, //  
                const bool              back=false,               //   
                const bool              selection=false,          //   
                const bool              hidden=true,              //    
                const long              z_order=0,                //    
                const int               timeFrames=OBJ_ALL_PERIODS)//    
  {
//---   
   ResetLastError();
//---   ""
   if(!ObjectCreate(chart_ID,name,OBJ_TEXT,sub_window,time,price))
     {
      Print(__FUNCTION__,
            ": failed to create \"Text\" object! Error code = ",GetLastError());
      return(false);
     }
//---  
   ObSetString(chart_ID,name,OBJPROP_TEXT,text);
//---    
   ObSetString(chart_ID,name,OBJPROP_TOOLTIP,toolTip);
//---   
   ObSetString(chart_ID,name,OBJPROP_FONT,font);
//---   
   ObSetIntegerInt(chart_ID,name,OBJPROP_FONTSIZE,font_size);
//---    
   ObSetDouble(chart_ID,name,OBJPROP_ANGLE,angle);
//---   
   ObSetIntegerAncorPoint(chart_ID,name,anchor);
//---  
   ObSetIntegerColor(chart_ID,name,OBJPROP_COLOR,clr);
//---    (false)   (true) 
   ObSetIntegerBool(chart_ID,name,OBJPROP_BACK,back);
//---  (true)   (false)    
   ObSetIntegerBool(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObSetIntegerBool(chart_ID,name,OBJPROP_SELECTED,selection);
//---  (true)   (false)      
   ObSetIntegerBool(chart_ID,name,OBJPROP_HIDDEN,hidden);
//---         
   ObSetIntegerLong(chart_ID,name,OBJPROP_ZORDER,z_order);
//---        
   ObSetIntegerInt(chart_ID,name,OBJPROP_TIMEFRAMES,timeFrames);
//---  
   return(true);
  }
//+------------------------------------------------------------------+
//|                                             |
//+------------------------------------------------------------------+
//|  :                                                       |
//|  MQL5 /  ,   |
//| /    /   / OBJ_LABEL                |
//+------------------------------------------------------------------+
bool LabelCreate(const long              chart_ID=0,               // ID 
                 const string            name="Label",             //  
                 const int               sub_window=0,             //  
                 const int               x=0,                      //    X
                 const int               y=0,                      //    Y
                 const string            toolTip="\n",             //   
                 const ENUM_BASE_CORNER  corner=CORNER_LEFT_UPPER, //    
                 const string            text="Label",             // 
                 const string            font="Arial",             // 
                 const int               font_size=10,             //  
                 const color             clr=clrRed,               // 
                 const double            angle=0.0,                //  
                 const ENUM_ANCHOR_POINT anchor=ANCHOR_LEFT_UPPER, //  
                 const bool              back=false,               //   
                 const bool              selection=false,          //   
                 const bool              hidden=true,              //    
                 const long              z_order=0,                //    
                 const int               timeFrames=OBJ_ALL_PERIODS)//    
  {
//---   
   ResetLastError();
//---   
   if(!ObjectCreate(chart_ID,name,OBJ_LABEL,sub_window,0,0))
     {
      Print(__FUNCTION__,
            ": failed to create text label! Error code = ",GetLastError());
      return(false);
     }
//---    
   ObSetString(chart_ID,name,OBJPROP_TOOLTIP,toolTip);
//---   
   ObSetIntegerInt(chart_ID,name,OBJPROP_XDISTANCE,x);
   ObSetIntegerInt(chart_ID,name,OBJPROP_YDISTANCE,y);
//---   ,      
   ObSetIntegerCorner(chart_ID,name,corner);//ENUM_BASE_CORNER
//---  
   ObSetString(chart_ID,name,OBJPROP_TEXT,text);
//---   
   ObSetString(chart_ID,name,OBJPROP_FONT,font);
//---   
   ObSetIntegerInt(chart_ID,name,OBJPROP_FONTSIZE,font_size);
//---    
   ObSetDouble(chart_ID,name,OBJPROP_ANGLE,angle);
//---   
   ObSetIntegerAncorPoint(chart_ID,name,anchor);
//---  
   ObSetIntegerColor(chart_ID,name,OBJPROP_COLOR,clr);
//---    (false)   (true) 
   ObSetIntegerBool(chart_ID,name,OBJPROP_BACK,back);
//---  (true)   (false)    
   ObSetIntegerBool(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObSetIntegerBool(chart_ID,name,OBJPROP_SELECTED,selection);
//---  (true)   (false)      
   ObSetIntegerBool(chart_ID,name,OBJPROP_HIDDEN,hidden);
//---         
   ObSetIntegerLong(chart_ID,name,OBJPROP_ZORDER,z_order);
//---        
   ObSetIntegerInt(chart_ID,name,OBJPROP_TIMEFRAMES,timeFrames);
//---  
   return(true);
  }
//+------------------------------------------------------------------+
//|                                                     |
//+------------------------------------------------------------------+
//|  :                                                       |
//|  MQL5 /  ,   |
//| /    /   / OBJ_BUTTON               |
//+------------------------------------------------------------------+
bool ButtonCreate(const long              chart_ID=0,               // ID 
                  const string            name="Button",            // 
                  const int               sub_window=0,             //  
                  const int               x=0,                      //    X
                  const int               y=0,                      //    Y
                  const int               width=50,                 //  
                  const int               height=18,                //  
                  const ENUM_BASE_CORNER  corner=CORNER_LEFT_UPPER, //    
                  const string            text="Button",            // 
                  const string            toolTip="\n",             //   
                  const string            font="Arial",             // 
                  const int               font_size=10,             //  
                  const color             clr=clrBlack,             //  
                  const color             back_clr=C'236,233,216',  //  
                  const color             border_clr=clrNONE,       //  
                  const bool              state=false,              // /
                  const bool              back=false,               //   
                  const bool              selection=false,          //   
                  const bool              hidden=true,              //    
                  const long              z_order=0,                //    
                  const int               timeFrames=OBJ_ALL_PERIODS)//    
  {
//---   
   ResetLastError();
//---  
   if(!ObjectCreate(chart_ID,name,OBJ_BUTTON,sub_window,0,0))
     {
      Print(LINE_NUMBER,__FUNCTION__,
            ": failed to create the button! Error code = ",GetLastError());
      return(false);
     }
//---   
   ObSetIntegerInt(chart_ID,name,OBJPROP_XDISTANCE,x);
   ObSetIntegerInt(chart_ID,name,OBJPROP_YDISTANCE,y);
//---   
   ObSetIntegerInt(chart_ID,name,OBJPROP_XSIZE,width);
   ObSetIntegerInt(chart_ID,name,OBJPROP_YSIZE,height);
//---   ,      
   ObSetIntegerCorner(chart_ID,name,corner);
//---  
   ObSetString(chart_ID,name,OBJPROP_TEXT,text);
//---   
   ObSetString(chart_ID,name,OBJPROP_FONT,font);
//---   
   ObSetIntegerInt(chart_ID,name,OBJPROP_FONTSIZE,font_size);
//---    
   ObSetString(chart_ID,name,OBJPROP_TOOLTIP,toolTip);
//---   
   ObSetIntegerColor(chart_ID,name,OBJPROP_COLOR,clr);
//---   
   ObSetIntegerColor(chart_ID,name,OBJPROP_BGCOLOR,back_clr);//   OBJ_EDIT, OBJ_BUTTON, OBJ_RECTANGLE_LABEL 
//---   
   ObSetIntegerColor(chart_ID,name,OBJPROP_BORDER_COLOR,border_clr);//     OBJ_EDIT  OBJ_BUTTON
//---    (false)   (true) 
   ObSetIntegerBool(chart_ID,name,OBJPROP_BACK,back);
//---     
   ObSetIntegerBool(chart_ID,name,OBJPROP_STATE,state);
//---  (true)   (false)    
   ObSetIntegerBool(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObSetIntegerBool(chart_ID,name,OBJPROP_SELECTED,selection);
//---  (true)   (false)      
   ObSetIntegerBool(chart_ID,name,OBJPROP_HIDDEN,hidden);
//---         
   ObSetIntegerLong(chart_ID,name,OBJPROP_ZORDER,z_order);
//---        
   ObSetIntegerInt(chart_ID,name,OBJPROP_TIMEFRAMES,timeFrames);
//---  
   return(true);
  }
//+------------------------------------------------------------------+
//|                                        |
//+------------------------------------------------------------------+
//|  :                                                       |
//|  MQL5 /  ,   |
//| /    /   / OBJ_BITMAP               |
//+------------------------------------------------------------------+
bool BitmapCreate(const long            chart_ID=0,        // ID 
                  const string          name="Bitmap",     //  
                  const int             sub_window=0,      //  
                  datetime              time=0,            //   
                  double                price=0,           //   
                  const string          file="",           //    
                  const int             width=10,          // X-  
                  const int             height=10,         // Y-  
                  const int             x_offset=0,        //     X
                  const int             y_offset=0,        //     Y
                  const string          toolTip="\n",      //   
                  const color           clr=clrRed,        //    
                  const ENUM_LINE_STYLE style=STYLE_SOLID, //    
                  const int             point_width=1,     //   
                  const bool            back=false,        //   
                  const bool            selection=false,   //   
                  const bool            hidden=true,       //    
                  const long            z_order=0,         //    
                  const int             timeFrames=OBJ_ALL_PERIODS)//    
  {
//---   
   ResetLastError();
//---  
   if(!ObjectCreate(chart_ID,name,OBJ_BITMAP,sub_window,time,price))
     {
      Print(__FUNCTION__,
            ": failed to create a bitmap in the chart window! Error code = ",GetLastError());
      return(false);
     }
//---      
   if(!ObjectSetString(chart_ID,name,OBJPROP_BMPFILE,file))
     {
      Print(__FUNCTION__,
            ": failed to load the image! Error code = ",GetLastError());
      return(false);
     }
//---    
   ObSetString(chart_ID,name,OBJPROP_TOOLTIP,toolTip);
//---    ;     
//---      ()  , 
//---   ;        ,
//---     ,    
   ObSetIntegerInt(chart_ID,name,OBJPROP_XSIZE,width);
   ObSetIntegerInt(chart_ID,name,OBJPROP_YSIZE,height);
//--- ,        
//---       ;  
//---          
   ObSetIntegerInt(chart_ID,name,OBJPROP_XOFFSET,x_offset);
   ObSetIntegerInt(chart_ID,name,OBJPROP_YOFFSET,y_offset);
//---        
   ObSetIntegerColor(chart_ID,name,OBJPROP_COLOR,clr);
//---         
   ObSetIntegerLineStyle(chart_ID,name,style);
//---    ,      
   ObSetIntegerInt(chart_ID,name,OBJPROP_WIDTH,point_width);
//---    (false)   (true) 
   ObSetIntegerBool(chart_ID,name,OBJPROP_BACK,back);
//---  (true)   (false)    
   ObSetIntegerBool(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObSetIntegerBool(chart_ID,name,OBJPROP_SELECTED,selection);
//---  (true)   (false)      
   ObSetIntegerBool(chart_ID,name,OBJPROP_HIDDEN,hidden);
//---         
   ObSetIntegerLong(chart_ID,name,OBJPROP_ZORDER,z_order);
//---        
   ObSetIntegerInt(chart_ID,name,OBJPROP_TIMEFRAMES,timeFrames);
//---  
   return(true);
  }
//+------------------------------------------------------------------+
//|   " "                               |
//+------------------------------------------------------------------+
//|  :                                                       |
//|  MQL5 /  ,   |
//| /    /   / OBJ_BITMAP_LABEL         |
//+------------------------------------------------------------------+
bool BitmapLabelCreate(const long              chart_ID=0,               // ID 
                       const string            name="BmpLabel",          //  
                       const int               sub_window=0,             //  
                       const int               x=0,                      //    X
                       const int               y=0,                      //    Y
                       const string            toolTip="\n",             //   
                       const string            file_on="",               //    On
                       const string            file_off="",              //    Off
                       const int               width=0,                  // X-  
                       const int               height=0,                 // Y-  
                       const int               x_offset=10,              //     X
                       const int               y_offset=10,              //     Y
                       const bool              state=false,              // /
                       const ENUM_BASE_CORNER  corner=CORNER_LEFT_UPPER, //    
                       const ENUM_ANCHOR_POINT anchor=ANCHOR_LEFT_UPPER, //   
                       const color             clr=clrRed,               //    
                       const ENUM_LINE_STYLE   style=STYLE_SOLID,        //    
                       const int               point_width=1,            //   
                       const bool              back=false,               //   
                       const bool              selection=false,          //   
                       const bool              hidden=true,              //    
                       const long              z_order=0,                //    
                       const int              timeFrames=OBJ_ALL_PERIODS)//    
  {
//---   
   ResetLastError();
//---   
   if(!ObjectCreate(chart_ID,name,OBJ_BITMAP_LABEL,sub_window,0,0))
     {
      Print(LINE_NUMBER,__FUNCTION__,
            ": failed to create \"Bitmap Label\" object! Error code = ",GetLastError());
      return(false);
     }
//---     On  Off
   if(!ObjectSetString(chart_ID,name,OBJPROP_BMPFILE,0,file_on))
     {
      Print(LINE_NUMBER,__FUNCTION__,
            ": failed to load the image for On mode! Error code = ",GetLastError());
      return(false);
     }
   if(!ObjectSetString(chart_ID,name,OBJPROP_BMPFILE,1,file_off))
     {
      Print(LINE_NUMBER,__FUNCTION__,
            ": failed to load the image for Off mode! Error code = ",GetLastError());
      return(false);
     }
//---    
   ObSetString(chart_ID,name,OBJPROP_TOOLTIP,toolTip);
//---   
   ObSetIntegerInt(chart_ID,name,OBJPROP_XDISTANCE,x);
   ObSetIntegerInt(chart_ID,name,OBJPROP_YDISTANCE,y);
//---    ;     
//---      ()  , 
//---   ;        ,
//---     ,    
   ObSetIntegerInt(chart_ID,name,OBJPROP_XSIZE,width);
   ObSetIntegerInt(chart_ID,name,OBJPROP_YSIZE,height);
//--- ,        
//---       ;  
//---          
   ObSetIntegerInt(chart_ID,name,OBJPROP_XOFFSET,x_offset);
   ObSetIntegerInt(chart_ID,name,OBJPROP_YOFFSET,y_offset);
//--- ,      (  )
   ObSetIntegerBool(chart_ID,name,OBJPROP_STATE,state);
//---   ,      
   ObSetIntegerCorner(chart_ID,name,corner);//ENUM_BASE_CORNER;
//---   
   ObSetIntegerAncorPoint(chart_ID,name,anchor);
//---        
   ObSetIntegerColor(chart_ID,name,OBJPROP_COLOR,clr);
//---         
   ObSetIntegerLineStyle(chart_ID,name,style);
//---    ,      
   ObSetIntegerInt(chart_ID,name,OBJPROP_WIDTH,point_width);
//---    (false)   (true) 
   ObSetIntegerBool(chart_ID,name,OBJPROP_BACK,back);
//---  (true)   (false)    
   ObSetIntegerBool(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObSetIntegerBool(chart_ID,name,OBJPROP_SELECTED,selection);
//---  (true)   (false)      
   ObSetIntegerBool(chart_ID,name,OBJPROP_HIDDEN,hidden);
//---         
   ObSetIntegerLong(chart_ID,name,OBJPROP_ZORDER,z_order);
//---        
   ObSetIntegerInt(chart_ID,name,OBJPROP_TIMEFRAMES,timeFrames);
//---  
   return(true);
  }
//+------------------------------------------------------------------+
//|   " "                                      |
//+------------------------------------------------------------------+
//|  :                                                       |
//|  MQL5 /  ,   |
//| /   /   / OBJ_EDIT                  |
//+------------------------------------------------------------------+
bool EditCreate(const long             chart_ID=0,               // ID 
                const string           name="Edit",              //  
                const int              sub_window=0,             //  
                const int              x=0,                      //    X
                const int              y=0,                      //    Y
                const int              width=50,                 // 
                const int              height=18,                // 
                const string           text="Text",              // 
                const string           font="Arial",             // 
                const int              font_size=10,             //  
                const string           toolTip="\n",             //   
                const ENUM_ALIGN_MODE  align=ALIGN_CENTER,       //  
                const bool             read_only=false,          //  
                const ENUM_BASE_CORNER corner=CORNER_LEFT_UPPER, //    
                const color            clr=clrBlack,             //  
                const color            back_clr=clrWhite,        //  
                const color            border_clr=clrNONE,       //  
                const bool             back=false,               //   
                const bool             selection=false,          //   
                const bool             hidden=true,              //    
                const long             z_order=0,                //    
                const int             timeFrames=OBJ_ALL_PERIODS)//    
  {
//---   
   ResetLastError();
//---   
   if(!ObjectCreate(chart_ID,name,OBJ_EDIT,sub_window,0,0))
     {
      Print(LINE_NUMBER,__FUNCTION__,
            ": failed to create \"Edit\" object! Error code = ",GetLastError());
      return(false);
     }
//---   
   ObSetIntegerInt(chart_ID,name,OBJPROP_XDISTANCE,x);
   ObSetIntegerInt(chart_ID,name,OBJPROP_YDISTANCE,y);
//---   
   ObSetIntegerInt(chart_ID,name,OBJPROP_XSIZE,width);
   ObSetIntegerInt(chart_ID,name,OBJPROP_YSIZE,height);
//---  
   ObSetString(chart_ID,name,OBJPROP_TEXT,text);
//---   
   ObSetString(chart_ID,name,OBJPROP_FONT,font);
//---   
   ObSetIntegerInt(chart_ID,name,OBJPROP_FONTSIZE,font_size);
//---      
   ObSetIntegerAlign(chart_ID,name,align);
//---   ,      
   ObSetIntegerBool(chart_ID,name,OBJPROP_READONLY,read_only);
//---    
   ObSetString(chart_ID,name,OBJPROP_TOOLTIP,toolTip);
//---   ,      
   ObSetIntegerCorner(chart_ID,name,corner);
//---   
   ObSetIntegerColor(chart_ID,name,OBJPROP_COLOR,clr);
//---   
   ObSetIntegerColor(chart_ID,name,OBJPROP_BGCOLOR,back_clr);//   OBJ_EDIT, OBJ_BUTTON, OBJ_RECTANGLE_LABEL
//---    
   ObSetIntegerColor(chart_ID,name,OBJPROP_BORDER_COLOR,border_clr);//     OBJ_EDIT  OBJ_BUTTON
//---    (false)   (true) 
   ObSetIntegerBool(chart_ID,name,OBJPROP_BACK,back);
//---  (true)   (false)    
   ObSetIntegerBool(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObSetIntegerBool(chart_ID,name,OBJPROP_SELECTED,selection);
//---  (true)   (false)      
   ObSetIntegerBool(chart_ID,name,OBJPROP_HIDDEN,hidden);
//---         
   ObSetIntegerLong(chart_ID,name,OBJPROP_ZORDER,z_order);
//---        
   ObSetIntegerInt(chart_ID,name,OBJPROP_TIMEFRAMES,timeFrames);
//---  
   return(true);
  }
//+------------------------------------------------------------------+
//|   ""                                |
//+------------------------------------------------------------------+
//|  :                                                       |
//|  MQL5 /  ,   |
//| /   /   / OBJ_EVENT                 |
//+------------------------------------------------------------------+
bool EventCreate(const long            chart_ID=0,      // ID 
                 const string          name="Event",    //  
                 const int             sub_window=0,    //  
                 const string          text="Text",     //  
                 datetime              time=0,          // 
                 const string          toolTip="\n",    //   
                 const color           clr=clrRed,      // 
                 const int             line_width=1,//    
                 const bool            back=false,      //   
                 const bool            selection=false, //   
                 const bool            hidden=true,     //    
                 const long            z_order=0,       //    
                 const int             timeFrames=OBJ_ALL_PERIODS)//    
  {
//---    ,      
   if(!time)
      time=TimeCurrent();
//---   
   ResetLastError();
//---   ""
   if(!ObjectCreate(chart_ID,name,OBJ_EVENT,sub_window,time,0))
     {
      Print(__FUNCTION__,
            ": failed to create \"Event\" object! Error code = ",GetLastError());
      return(false);
     }
//---    
   ObSetString(chart_ID,name,OBJPROP_TOOLTIP,toolTip);
//---   
   ObSetString(chart_ID,name,OBJPROP_TEXT,text);
//---  
   ObSetIntegerColor(chart_ID,name,OBJPROP_COLOR,clr);
//---    ,   
   ObSetIntegerInt(chart_ID,name,OBJPROP_WIDTH,line_width);
//---    (false)   (true) 
   ObSetIntegerBool(chart_ID,name,OBJPROP_BACK,back);
//---  (true)   (false)    
   ObSetIntegerBool(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObSetIntegerBool(chart_ID,name,OBJPROP_SELECTED,selection);
//---  (true)   (false)      
   ObSetIntegerBool(chart_ID,name,OBJPROP_HIDDEN,hidden);
//---         
   ObSetIntegerLong(chart_ID,name,OBJPROP_ZORDER,z_order);
//---        
   ObSetIntegerInt(chart_ID,name,OBJPROP_TIMEFRAMES,timeFrames);
//---  
   return(true);
  }
//+------------------------------------------------------------------+
//|                                         |
//+------------------------------------------------------------------+
//|  :                                                       |
//|  MQL5 /  ,   |
//| /   /   / OBJ_RECTANGLE_LABEL       |
//+------------------------------------------------------------------+
bool RectLabelCreate(const long             chart_ID=0,               // ID 
                     const string           name="RectLabel",         //  
                     const int              sub_window=0,             //  
                     const int              x=0,                      //    X
                     const int              y=0,                      //    Y                     
                     const int              width=50,                 // 
                     const int              height=18,                // 
                     const string           toolTip="\n",             //   
                     const color            back_clr=C'236,233,216',  //  
                     const ENUM_BORDER_TYPE border=BORDER_SUNKEN,     //  
                     const ENUM_BASE_CORNER corner=CORNER_LEFT_UPPER, //    
                     const color            clr=clrRed,               //    (Flat)
                     const ENUM_LINE_STYLE  style=STYLE_SOLID,        //   
                     const int              line_width=1,             //   
                     const bool             back=false,               //   
                     const bool             selection=false,          //   
                     const bool             hidden=true,              //                      
                     const long             z_order=0,                //    
                     const int              timeFrames=OBJ_ALL_PERIODS)//    
  {
//---   
   ResetLastError();
//---   
   if(!ObjectCreate(chart_ID,name,OBJ_RECTANGLE_LABEL,sub_window,0,0))
     {
      Print(LINE_NUMBER,__FUNCTION__,
            ": failed to create a rectangle label! Error code = ",GetLastError());
      return(false);
     }
//---    
   ObSetString(chart_ID,name,OBJPROP_TOOLTIP,toolTip);
//---   
   ObSetIntegerInt(chart_ID,name,OBJPROP_XDISTANCE,x);
   ObSetIntegerInt(chart_ID,name,OBJPROP_YDISTANCE,y);
//---    
   ObSetIntegerInt(chart_ID,name,OBJPROP_XSIZE,width);
   ObSetIntegerInt(chart_ID,name,OBJPROP_YSIZE,height);
//---   
   ObSetIntegerColor(chart_ID,name,OBJPROP_BGCOLOR,back_clr);//   OBJ_EDIT, OBJ_BUTTON, OBJ_RECTANGLE_LABEL
//---   
   ObSetIntegerBorderType(chart_ID,name,border);
//---   ,      
   ObSetIntegerCorner(chart_ID,name,corner);
//---     (  Flat)
   ObSetIntegerColor(chart_ID,name,OBJPROP_COLOR,clr);
//---       
   ObSetIntegerLineStyle(chart_ID,name,style);
//---    
   ObSetIntegerInt(chart_ID,name,OBJPROP_WIDTH,line_width);
//---    (false)   (true) 
   ObSetIntegerBool(chart_ID,name,OBJPROP_BACK,back);
//---  (true)   (false)    
   ObSetIntegerBool(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObSetIntegerBool(chart_ID,name,OBJPROP_SELECTED,selection);//  (true)   (false)
//---  (true)   (false)      
   ObSetIntegerBool(chart_ID,name,OBJPROP_HIDDEN,hidden);
//---         
   ObSetIntegerLong(chart_ID,name,OBJPROP_ZORDER,z_order);
//---        
   ObSetIntegerInt(chart_ID,name,OBJPROP_TIMEFRAMES,timeFrames);
//---  
   return(true);
  }
//+--------------------------------------------------------------------+
//|   ,   :        |
//+--------------------------------------------------------------------+
//+--------------------------------------------------------------------+
//| ObSetDouble (  ,   )|
//|   ENUM_OBJECT_PROPERTY_DOUBLE:                 |
//+--------------------------------------------------------------------+
//| OBJPROP_SCALE -  (     "   |
//| ")  - double;                                             |
//+--------------------------------------------------------------------+
//| OBJPROP_ANGLE -  (    ,        |
//|     ).              |
//|  ,   ,   EMPTY_VALUE |
//| - double;                                                          |
//+--------------------------------------------------------------------+
//| OBJPROP_DEVIATION -       |
//| - double;                                                          |
//+--------------------------------------------------------------------+
bool ObSetDouble(long chart_ID,//  
                 string name,//  
                 ENUM_OBJECT_PROPERTY_DOUBLE prop_id,// 
                 double prop_value)// 
  {
   ResetLastError();
   if(!ObjectSetDouble(chart_ID,name,prop_id,prop_value))
     {
      Print(LINE_NUMBER,__FUNCTION__,", Error Code = ",GetLastError());
      return(false);
     }
   return(true);
  }
//+------------------------------------------------------------------+
//|       " " |
//| ( OBJ_EDIT)                                                   |
//+------------------------------------------------------------------+
//| OBJPROP_ALIGN -          |
//| " " (OBJ_EDIT) - ENUM_ALIGN_MODE;                       |
//+------------------------------------------------------------------+
bool ObSetIntegerAlign(long chart_ID,//  
                       string name,//  
                       ENUM_ALIGN_MODE prop_value)// 
  {
   ResetLastError();
   if(!ObjectSetInteger(chart_ID,name,OBJPROP_ALIGN,prop_value))
     {
      Print(LINE_NUMBER,__FUNCTION__,", Error Code = ",
            GetLastError());
      return(false);
     }
   return(true);
  }
//+------------------------------------------------------------------+
//| ObSetIntegerAncorPoint (  ,   |
//| )                                                    |
//+------------------------------------------------------------------+
//| OBJPROP_ANCHOR -     :  |
//| - ENUM_ANCHOR_POINT ( OBJ_LABEL, OBJ_BITMAP_LABEL  OBJ_TEXT);|
//+------------------------------------------------------------------+
bool ObSetIntegerAncorPoint(long chart_ID,//  
                            string name,//  
                            ENUM_ANCHOR_POINT prop_value)// 
  {
   ResetLastError();
   if(!ObjectSetInteger(chart_ID,name,OBJPROP_ANCHOR,prop_value))
     {
      Print(LINE_NUMBER,__FUNCTION__,", Error Code = ",
            GetLastError());
      return(false);
     }
   return(true);
  }
//+------------------------------------------------------------------+
//| ObSetIntegerArrowAncor (  ,   |
//| )                                                    |
//+------------------------------------------------------------------+
//| OBJPROP_ANCHOR -     :  |
//| - ENUM_ARROW_ANCHOR ( OBJ_ARROW);                             |
//+------------------------------------------------------------------+
bool ObSetIntegerArrowAncor(long chart_ID,//  
                            string name,//  
                            ENUM_ARROW_ANCHOR prop_value)// 
  {
   ResetLastError();
   if(!ObjectSetInteger(chart_ID,name,OBJPROP_ANCHOR,prop_value))
     {
      Print(LINE_NUMBER,__FUNCTION__,", Error Code = ",
            GetLastError());
      return(false);
     }
   return(true);
  }
//+------------------------------------------------------------------+
//| ObSetIntegerArrowCode (  ,    |
//| )                                                    |
//+------------------------------------------------------------------+
//| OBJPROP_ARROWCODE -     "" - char     |
//+------------------------------------------------------------------+
bool ObSetIntegerArrowCode(long chart_ID,//  
                           string name,//  
                           char prop_value)// 
  {
   ResetLastError();
   if(!ObjectSetInteger(chart_ID,name,OBJPROP_ARROWCODE,prop_value))
     {
      Print(LINE_NUMBER,__FUNCTION__,", Error Code = ",
            GetLastError());
      return(false);
     }
   return(true);
  }
//+-------------------------------------------------------------------+
//| ObSetIntegerBool (  ,          |
//| )                                                     |
//|   ENUM_OBJECT_PROPERTY_INTEGER:               |
//+-------------------------------------------------------------------+
//| OBJPROP_BACK -     - bool;                     |
//+-------------------------------------------------------------------+
//| OBJPROP_FILL    ( OBJ_RECTANGLE,           |
//| OBJ_TRIANGLE, OBJ_ELLIPSE, OBJ_CHANNEL, OBJ_STDDEVCHANNEL,        |
//| OBJ_REGRESSION) - bool;                                           |
//+-------------------------------------------------------------------+
//| OBJPROP_HIDDEN -            |
//|      "" - "" - " |
//| ". true     |
//|   .  true   ,  |
//|    ,  ,     |
//|    MQL5-.          |
//|        ,  |
//|  ""   " ". - bool                     |
//+-------------------------------------------------------------------+
//| OBJPROP_SELECTED -   - bool;                   |
//+-------------------------------------------------------------------+
//| OBJPROP_READONLY -         |
//| Edit - bool;                                                      |
//+-------------------------------------------------------------------+
//| OBJPROP_SELECTABLE -   - bool;                  |
//+-------------------------------------------------------------------+
//| OBJPROP_RAY_LEFT -    - bool;                 |
//+-------------------------------------------------------------------+
//| OBJPROP_RAY_RIGHT -    - bool;               |
//+-------------------------------------------------------------------+
//| OBJPROP_RAY -        |
//| - bool;                                                           |
//+-------------------------------------------------------------------+
//| OBJPROP_ELLIPSE -              |
//| " " (OBJ_FIBOARC) - bool;                            |
//+-------------------------------------------------------------------+
//| OBJPROP_DRAWLINES -            |
//|  - bool;                                                   |
//+-------------------------------------------------------------------+
//| OBJPROP_STATE -   (/) - bool;          |
//+-------------------------------------------------------------------+
//| OBJPROP_DATE_SCALE -      |
//| "" - bool;                                                  |
//+-------------------------------------------------------------------+
//| OBJPROP_PRICE_SCALE -            |
//|  "" - bool;                                          |
//+-------------------------------------------------------------------+
bool ObSetIntegerBool(long chart_ID,//  
                      string name,//  
                      ENUM_OBJECT_PROPERTY_INTEGER prop_id,// 
                      bool prop_value)// 
  {
   ResetLastError();
   if(!ObjectSetInteger(chart_ID,name,prop_id,prop_value))
     {
      Print(LINE_NUMBER,__FUNCTION__,", Error Code = ",
            GetLastError());
      return(false);
     }
   return(true);
  }
//+------------------------------------------------------------------+
//|      " "               |
//+------------------------------------------------------------------+
//| OBJPROP_BORDER_TYPE -     " "|
//| - ENUM_BORDER_TYPE;                                              |
//+------------------------------------------------------------------+
bool ObSetIntegerBorderType(long chart_ID,//  
                            string name,//  
                            ENUM_BORDER_TYPE prop_value)// 
  {
   ResetLastError();
   if(!ObjectSetInteger(chart_ID,name,OBJPROP_BORDER_TYPE,prop_value))
     {
      Print(LINE_NUMBER,__FUNCTION__,", Error Code = ",
            GetLastError());
      return(false);
     }
   return(true);
  }
//+--------------------------------------------------------------------+
//| ObSetIntegerColor (  ,          |
//| )                                                      |
//|   ENUM_OBJECT_PROPERTY_INTEGER:                |
//+--------------------------------------------------------------------+
//| OBJPROP_COLOR -  (       ,|
//|    ..) - color                                            |
//+--------------------------------------------------------------------+
//| OBJPROP_BGCOLOR -    OBJ_EDIT, OBJ_BUTTON,              |
//| OBJ_RECTANGLE_LABEL - color;                                       |
//+--------------------------------------------------------------------+
//| OBJPROP_BORDER_COLOR -     OBJ_EDIT            |
//| OBJ_BUTTON - color;                                                |
//+--------------------------------------------------------------------+
bool ObSetIntegerColor(long chart_ID,//  
                       string name,//  
                       ENUM_OBJECT_PROPERTY_INTEGER prop_id,// 
                       color prop_value)// 
  {
   ResetLastError();
   if(!ObjectSetInteger(chart_ID,name,prop_id,prop_value))
     {
      Print(LINE_NUMBER,__FUNCTION__,", Error Code = ",
            GetLastError());
      return(false);
     }
   return(true);
  }
//+------------------------------------------------------------------+
//|                   |
//+------------------------------------------------------------------+
//| OBJPROP_CORNER -        |
//| - ENUM_BASE_CORNER;                                              |
//+------------------------------------------------------------------+
bool ObSetIntegerCorner(long chart_ID,//  
                        string name,//  
                        ENUM_BASE_CORNER prop_value)// 
  {
   ResetLastError();
   if(!ObjectSetInteger(chart_ID,name,OBJPROP_CORNER,prop_value))
     {
      Print(LINE_NUMBER,__FUNCTION__,", Error Code = ",
            GetLastError());
      return(false);
     }
   return(true);
  }
//+--------------------------------------------------------------------+
//| ObSetIntegerInt (  ,            |
//| )                                                      |
//|   ENUM_OBJECT_PROPERTY_INTEGER:                |
//+--------------------------------------------------------------------+
//| OBJPROP_WIDTH -   - int;                               |
//+--------------------------------------------------------------------+
//| OBJPROP_LEVELS -   - int;                         |
//+--------------------------------------------------------------------+
//| OBJPROP_FONTSIZE -   - int;                            |
//+--------------------------------------------------------------------+
//| OBJPROP_TIMEFRAMES -     -       |
//|  flags;int                                                   |
//+--------------------------------------------------------------------+
//| OBJPROP_XDISTANCE -      X            |
//|  (.     MQL5) - int;             |
//+--------------------------------------------------------------------+
//| OBJPROP_YDISTANCE -      Y            |
//|  (.     MQL5) - int;             |
//+--------------------------------------------------------------------+
//| OBJPROP_XSIZE -     X  .     |
//|  OBJ_LABEL (read only), OBJ_BUTTON, OBJ_CHART, OBJ_BITMAP, |
//| OBJ_BITMAP_LABEL, OBJ_EDIT, OBJ_RECTANGLE_LABEL. - int;            |
//+--------------------------------------------------------------------+
//| OBJPROP_YSIZE -     Y  .     |
//|  OBJ_LABEL (read only), OBJ_BUTTON, OBJ_CHART, OBJ_BITMAP, |
//| OBJ_BITMAP_LABEL, OBJ_EDIT, OBJ_RECTANGLE_LABEL. - int;            |
//+--------------------------------------------------------------------+
//| OBJPROP_XOFFSET - X-      |
//|       " "     |
//| "" (OBJ_BITMAP_LABEL  OBJ_BITMAP).        |
//|       .|
//| - int;                                                             |
//+--------------------------------------------------------------------+
//| OBJPROP_YOFFSET - Y-      |
//|       " "     |
//| "" (OBJ_BITMAP_LABEL  OBJ_BITMAP).        |
//|       .|
//| - int;                                                             |
//+--------------------------------------------------------------------+
//| OBJPROP_CHART_SCALE -    "" - int           |
//|    05                                           |
//+--------------------------------------------------------------------+
bool ObSetIntegerInt(long chart_ID,//  
                     string name,//  
                     ENUM_OBJECT_PROPERTY_INTEGER prop_id,// 
                     int prop_value)// 
  {
   ResetLastError();
   if(!ObjectSetInteger(chart_ID,name,prop_id,prop_value))
     {
      Print(LINE_NUMBER,__FUNCTION__,", Error Code = ",
            GetLastError());
      return(false);
     }
   return(true);
  }
//+------------------------------------------------------------------+
//| ObSetIntegerLineStyle (  ,    |
//| )                                                    |
//|   ENUM_OBJECT_PROPERTY_INTEGER:              |
//+------------------------------------------------------------------+
//| OBJPROP_STYLE -  - ENUM_LINE_STYLE;                         |
//+------------------------------------------------------------------+
bool ObSetIntegerLineStyle(long chart_ID,//  
                           string name,//  
                           ENUM_LINE_STYLE prop_value)// 
  {
   ResetLastError();
   if(!ObjectSetInteger(chart_ID,name,OBJPROP_STYLE,prop_value))
     {
      Print(LINE_NUMBER,__FUNCTION__,", Error Code = ",
            GetLastError());
      return(false);
     }
   return(true);
  }
//+-------------------------------------------------------------------+
//| ObSetIntegerLong (  ,          |
//| )                                                     |
//|   ENUM_OBJECT_PROPERTY_INTEGER:               |
//+-------------------------------------------------------------------+
//| OBJPROP_ZORDER -           |
//|      (CHARTEVENT_CLICK).   |
//|     ,               |
//|    .       |
//|     CHARTEVENT_CLICK    ,|
//|    . - long;                             |
//+-------------------------------------------------------------------+
bool ObSetIntegerLong(long chart_ID,//  
                      string name,//  
                      ENUM_OBJECT_PROPERTY_INTEGER prop_id,// 
                      long prop_value)// 
  {
   ResetLastError();
   if(!ObjectSetInteger(chart_ID,name,prop_id,prop_value))
     {
      Print(LINE_NUMBER,__FUNCTION__,", Error Code = ",
            GetLastError());
      return(false);
     }
   return(true);
  }
//+--------------------------------------------------------------------+
//| ObSetString (  ,   )|
//|   ENUM_OBJECT_PROPERTY_STRING:                 |
//+--------------------------------------------------------------------+
//| OBJPROP_NAME -   - string;                               |
//+--------------------------------------------------------------------+
//| OBJPROP_TEXT -   (,   )-   |
//| string;                                                            |
//+--------------------------------------------------------------------+
//| OBJPROP_TOOLTIP -   .       |
//| ,   ,      |
//| .     ,       |
//|  "\n" ( )- string;                            |
//+--------------------------------------------------------------------+
//| OBJPROP_FONT -  - string;                                     |
//+--------------------------------------------------------------------+
//| OBJPROP_SYMBOL    "" - string.               |
//+--------------------------------------------------------------------+
bool ObSetString(long chart_ID,//  
                 string name,//  
                 ENUM_OBJECT_PROPERTY_STRING prop_id,// 
                 string prop_value)// 
  {
   ResetLastError();
   if(!ObjectSetString(chart_ID,name,prop_id,prop_value))
     {
      Print(LINE_NUMBER,__FUNCTION__,", Error Code = ",
            GetLastError());
      return(false);
     }
   return(true);
  }
//+------------------------------------------------------------------+
//|    ,   :    |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//| ObSetDoubleMod (  ,           |
//| )  ENUM_OBJECT_PROPERTY_DOUBLE:  |
//+------------------------------------------------------------------+
//| OBJPROP_PRICE -   - double  = |
//| ;                                                        |
//+------------------------------------------------------------------+
//| OBJPROP_LEVELVALUE -   - double  = |
//| ;                                                          |
//+------------------------------------------------------------------+
bool ObSetDoubleMod(long chart_ID,//  
                    string name,//  
                    ENUM_OBJECT_PROPERTY_DOUBLE prop_id,// 
                    int prop_modifier,
                    double prop_value)// 
  {
   ResetLastError();
   if(!ObjectSetDouble(chart_ID,name,prop_id,prop_modifier,prop_value))
     {
      Print(LINE_NUMBER,__FUNCTION__,", Error Code = ",GetLastError());
      return(false);
     }
   return(true);
  }
//+------------------------------------------------------------------+
//| ObSetIntegerLelelColorMod (  ,         |
//|  )                                          |
//|   ENUM_OBJECT_PROPERTY_INTEGER:              |
//+------------------------------------------------------------------+
//| OBJPROP_LEVELCOLOR -  - - color = |
//| ;                                                          |
//+------------------------------------------------------------------+
bool ObSetIntegerLevelColorMod(long chart_ID,//  
                               string name,//  
                               int prop_modifier,// 
                               color prop_value)// 
  {
   ResetLastError();
   if(!ObjectSetInteger(chart_ID,name,OBJPROP_LEVELCOLOR,
      prop_modifier,prop_value))
     {
      Print(LINE_NUMBER,__FUNCTION__,", Error Code = ",
            GetLastError());
      return(false);
     }
   return(true);
  }
//+------------------------------------------------------------------+
//| ObSetIntegerLevelStyleMod (  ,         |
//|  )                                          |
//|   ENUM_OBJECT_PROPERTY_INTEGER:              |
//+------------------------------------------------------------------+
//| OBJPROP_LEVELSTYLE -  - ENUM_LINE_STYLE          |
//| = ;                                        |
//+------------------------------------------------------------------+
bool ObSetIntegerLevelStyleMod(long chart_ID,//  
                               string name,//  
                               int prop_modifier,// 
                               ENUM_LINE_STYLE prop_value)// 
  {
   ResetLastError();
   if(!ObjectSetInteger(chart_ID,name,OBJPROP_LEVELSTYLE,
      prop_modifier,prop_value))
     {
      Print(LINE_NUMBER,__FUNCTION__,", Error Code = ",
            GetLastError());
      return(false);
     }
   return(true);
  }
//+------------------------------------------------------------------+
//| ObSetIntegerLevelWidthMod (  ,         |
//|  )                                          |
//|   ENUM_OBJECT_PROPERTY_INTEGER:              |
//+------------------------------------------------------------------+
//| OBJPROP_LEVELWIDTH -  - - int                  |
//| = ;                                        |
//+------------------------------------------------------------------+
bool ObSetIntegerLevelWidthMod(long chart_ID,//  
                               string name,//  
                               int prop_modifier,// 
                               int prop_value)// 
  {
   ResetLastError();
   if(!ObjectSetInteger(chart_ID,name,OBJPROP_LEVELWIDTH,
      prop_modifier,prop_value))
     {
      Print(LINE_NUMBER,__FUNCTION__,", Error Code = ",
            GetLastError());
      return(false);
     }
   return(true);
  }
//+------------------------------------------------------------------+
//| ObSetIntegerTimeMod (  ,      |
//| )                                                    |
//|   ENUM_OBJECT_PROPERTY_INTEGER:              |
//+------------------------------------------------------------------+
//| OBJPROP_TIME -   - datetime   = |
//|  ;                                                  |
//+------------------------------------------------------------------+
bool ObSetIntegerTimeMod(long chart_ID,//  
                         string name,//  
                         int prop_modifier,// 
                         datetime prop_value)// 
  {
   ResetLastError();
   if(!ObjectSetInteger(chart_ID,name,OBJPROP_TIME,prop_modifier,
      prop_value))
     {
      Print(LINE_NUMBER,__FUNCTION__,", Error Code = ",
            GetLastError());
      return(false);
     }
   return(true);
  }
//+-----------------------------------------------------------------------+
//| ObSetStringMod (  ,   )|
//|   ENUM_OBJECT_PROPERTY_STRING:                    |
//+-----------------------------------------------------------------------+
//| OBJPROP_LEVELTEXT -   - string    =     |
//| ;                                                               |
//+-----------------------------------------------------------------------+
//| OBJPROP_BMPFILE -  BMP-   " ".      |
//|    - string                                       |
//| : 0- ON, 1- OFF;                         |
//+-----------------------------------------------------------------------+
bool ObSetStringMod(long chart_ID,//  
                    string name,//  
                    ENUM_OBJECT_PROPERTY_STRING prop_id,// 
                    int prop_modifier,// 
                    string prop_value)// 
  {
   ResetLastError();
   if(!ObjectSetString(chart_ID,name,prop_id,prop_modifier,prop_value))
     {
      Print(LINE_NUMBER,__FUNCTION__,", Error Code = ",
            GetLastError());
      return(false);
     }
   return(true);
  }
//+------------------------------------------------------------------+
//|                                                  |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                         |
//+------------------------------------------------------------------+
bool ObDelete(long chart_ID,string name)
  {
   if(ObjectFind(chart_ID,name)>-1)
     {
      ResetLastError();
      if(!ObjectDelete(chart_ID,name))
        {
         Print(LINE_NUMBER,__FUNCTION__,", Error Code = ",
               GetLastError(),", name: ",name);
         return(false);
        }
     }
   return(true);
  }
//+------------------------------------------------------------------+
